<template>
    <BudgetNavigation/>
    <div class="row">
        <div class="col-12">
            <h4>Отображения</h4>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <BudgetPresentationAdd
                :municipalityId="municipalityId"
                @presentationAdded="presentationsListUpdateRequired = true"/>
            <BudgetPresentationsTable
                :presentationsList="presentationsList"/>
        </div>
    </div>
</template>

<script>
    import BudgetNavigation from '../BudgetNavigation.vue'
    import BudgetPresentationAdd from './BudgetPresentationAdd'
    import BudgetPresentationsTable from './BudgetPresentationsTable'
    import { BudgetPresentationsService } from '../../services/budgetPresentationsService'
    import { defaultHandleErrorFunction } from '@/services/http-common'

    export default {
        name: 'BudgetPresentationsList',
        components: {
            BudgetNavigation,
            BudgetPresentationAdd,
            BudgetPresentationsTable
        },
        props: {
            municipalityId: Number
        },
        data() {
            return {
                presentationsList: [],
                presentationsListUpdateRequired: true
            }
        },
        methods: {
            checkUpdateRequired(){
                if (this.presentationsListUpdateRequired) {
                    this.updatePresentationsList();
                    this.presentationsListUpdateRequired = false;
                }
            },
            updatePresentationsList() {
                budgetPresentationsService
                    .get(this.municipalityId)
                    .then(response => this.presentationsList = response.data)
                    .catch(defaultHandleErrorFunction);
            }
        },
        watch: {
            presentationsListUpdateRequired: function (val) {
                this.checkUpdateRequired();
            },
        },
        created() {
            this.checkUpdateRequired();
        }
    };

    const budgetPresentationsService = new BudgetPresentationsService();
</script>
